# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetZeroTrustRiskBehaviorResult',
    'AwaitableGetZeroTrustRiskBehaviorResult',
    'get_zero_trust_risk_behavior',
    'get_zero_trust_risk_behavior_output',
]

@pulumi.output_type
class GetZeroTrustRiskBehaviorResult:
    """
    A collection of values returned by getZeroTrustRiskBehavior.
    """
    def __init__(__self__, account_id=None, behaviors=None, id=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if behaviors and not isinstance(behaviors, dict):
            raise TypeError("Expected argument 'behaviors' to be a dict")
        pulumi.set(__self__, "behaviors", behaviors)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def behaviors(self) -> Mapping[str, 'outputs.GetZeroTrustRiskBehaviorBehaviorsResult']:
        return pulumi.get(self, "behaviors")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetZeroTrustRiskBehaviorResult(GetZeroTrustRiskBehaviorResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZeroTrustRiskBehaviorResult(
            account_id=self.account_id,
            behaviors=self.behaviors,
            id=self.id)


def get_zero_trust_risk_behavior(account_id: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZeroTrustRiskBehaviorResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_risk_behavior = cloudflare.get_zero_trust_risk_behavior(account_id="account_id")
    ```
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZeroTrustRiskBehavior:getZeroTrustRiskBehavior', __args__, opts=opts, typ=GetZeroTrustRiskBehaviorResult).value

    return AwaitableGetZeroTrustRiskBehaviorResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        behaviors=pulumi.get(__ret__, 'behaviors'),
        id=pulumi.get(__ret__, 'id'))
def get_zero_trust_risk_behavior_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZeroTrustRiskBehaviorResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_risk_behavior = cloudflare.get_zero_trust_risk_behavior(account_id="account_id")
    ```
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZeroTrustRiskBehavior:getZeroTrustRiskBehavior', __args__, opts=opts, typ=GetZeroTrustRiskBehaviorResult)
    return __ret__.apply(lambda __response__: GetZeroTrustRiskBehaviorResult(
        account_id=pulumi.get(__response__, 'account_id'),
        behaviors=pulumi.get(__response__, 'behaviors'),
        id=pulumi.get(__response__, 'id')))
